//----------------------------------------------------------------------------------------------------
/*
 * Standard client side behavior for entity management ( JavaScript ) 
 */
//----------------------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------
function trace(msg)
{
	alert ( "TRACE : \n" + msg);
}
//----------------------------------------------------------------------------------------------------
function checkResponse(response)
{
	if ( ! response.isOK() )
	{
		alert ( "ERROR : \n Response return code = " + response.getReturnCode() );	
	}	
}
//----------------------------------------------------------------------------------------------------
// Call the server side to OPEN the ScreenContext (use a new Screen Context) 
//----------------------------------------------------------------------------------------------------
function actionOpen()
{
	trace ( "actionOpen()  ");
	var response = actions.doOpen();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to CLOSE the current Screen Context 
//----------------------------------------------------------------------------------------------------
function actionClose()
{
	trace ( "actionClose()  ");
	var response = actions.doClose();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to SET the given data in the Screen Context 
//----------------------------------------------------------------------------------------------------
function actionSet()
{
	trace ( "actionSet()  ");
	var response = actions.doSet();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to GET the Screen Context data 
//----------------------------------------------------------------------------------------------------
function actionGet()
{
	trace ( "actionGet()  ");
	var response = actions.doGet(); // Update Screen (by default)
	//response.show();
	//var response = actions.doGet(true); // Update Screen 
	//var response = actions.doGet(false); // Do NOT update screen
	
	checkResponse(response);
	// The code below replaces "actions.doGet_DataVoid()"
	if ( response.isOK() && response.dataVoid() )
	{
		alert ( "No data !" );	
	}	
}
//----------------------------------------------------------------------------------------------------
// Call the server side to CLEAR the Screen Context 
//----------------------------------------------------------------------------------------------------
function actionClear()
{
	trace ( "actionClear()  ");
	var response = actions.doClear(); // Update Screen (by default)
	//actions.doClear(false); // Clear context but DO NOT Update Screen	
	checkResponse(response);
}

//----------------------------------------------------------------------------------------------------
// Call the server side to LOAD the entity corresponding to the given Primary Key   
//----------------------------------------------------------------------------------------------------
function actionLoad()
{
	trace ( "actionLoad()  ");
	setKeyParam();
	var response = actions.doLoad(); // Update Screen (by default)
	checkResponse(response);
	if ( response.isOK() && response.dataNotFound() )
	{
		alert ( "Data not found !" );
	}
}
//----------------------------------------------------------------------------------------------------
// Call the server side to SAVE ( CREATE or UPDATE ) the entity  
//----------------------------------------------------------------------------------------------------
function actionSave()
{
	trace ( "actionSave()  ");
    //actions.setElementToRetrieve("element_name");
    //actions.setViewToRetrieve("view_name");
    var response = actions.doSave();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to CREATE the entity  
//----------------------------------------------------------------------------------------------------
function actionInsert()
{
	trace ( "actionInsert()  ");
    //actions.setElementToRetrieve("element_name");
    //actions.setViewToRetrieve("view_name");
    var response = actions.doInsert();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to UPDATE the entity  
//----------------------------------------------------------------------------------------------------
function actionUpdate()
{
	trace ( "actionUpdate()  ");
	//actions.setElementToRetrieve("element_name");
    //actions.setViewToRetrieve("view_name");
	var response = actions.doUpdate();
	checkResponse(response);
}
//----------------------------------------------------------------------------------------------------
// Call the server side to DELETE the entity 
//----------------------------------------------------------------------------------------------------
function actionDelete()
{
   	trace ( "actionDelete()  ");
   	setKeyParam(); // Call setKeyParam() to delete by Primary Key (else delete current)
   	var response = actions.doDelete(); // Clear Screen (by default)
   	//actions.doNotClearContextData();
    //actions.setElementToRetrieve("element_name");
    //actions.setViewToRetrieve("view_name");
    //actions.doDelete(true, true); // Clear Screen && Update Fields & Views
	checkResponse(response);
}

//----------------------------------------------------------------------------------------------------
// Set the PK values as request parameters 
//----------------------------------------------------------------------------------------------------
function setKeyParam()
{
    alert("The 'setKeyParam()' function must be overriden in each screen !");
}

//----------------------------------------------------------------------------------------------------
// Clear all the screen fields 
//----------------------------------------------------------------------------------------------------
function clearScreen()
{
	theScreen.clear();
}
//----------------------------------------------------------------------------------------------------
